SystemOrganization addCategory: #'Mondrian-Util'!
SystemOrganization addCategory: #'Mondrian-Util-Tests'!

!MOBoundedShape methodsFor: '*mondrian-util' stamp: 'AlexandreBergel 4/29/2011 15:11'!
linearFontSize: anObject within: aCollection
	"Set the linear font size for the nodes. The gradient goes from 0 to the maximum, obtained from aCollection. anObject could be a symbol, a block or a value. anObject is evaluated against the model of the node to be paint. aGroup is a collection of the model values. This is where the maximum is looked into."
	
	fontSize := MONFontLinearNormalizer inContext: aCollection withCommand: anObject! !

!MOFilledShape methodsFor: '*mondrian-util' stamp: 'FAbrizioPerin 5/9/2012 15:23'!
identityBorderColorOf: aBlockOrObject
	"Set the border color based on the identity returned by the block."

	borderColor := MONIdentityNormalizer withCommand: aBlockOrObject! !

!MOFilledShape methodsFor: '*mondrian-util' stamp: 'TudorGirba 7/5/2011 10:06'!
identityFillColorOf: aBlockOrObject
	"Set the fill color based on the identity returned by the block."

	fillColor := MONIdentityNormalizer withCommand: aBlockOrObject! !

!MOFilledShape methodsFor: '*mondrian-util' stamp: 'AlexandreBergel 4/29/2011 14:50'!
linearBlueFillColor: anObject within: aGroup
	"Set the linear fill color for the nodes. The gradient goes from white to intense blue. anObject could be a symbol, a block or a value. anObject is evaluated against the model of the node to be paint. aGroup is a collection of the model values. This is where the maximum is looked into."

	fillColor := MONColorLinearNormalizer 
						inContext: aGroup 
						withCommand: anObject
						lowColor: Color white
						highColor: Color blue! !

!MOFilledShape methodsFor: '*mondrian-util' stamp: 'AlexandreBergel 4/29/2011 14:50'!
linearFillColor: anObject within: aGroup
	"Set the linear fill color for the nodes. The gradient goes from white to black. anObject could be a symbol, a block or a value. anObject is evaluated against the model of the node to be paint. aGroup is a collection of the model values. This is where the maximum is looked into."

	fillColor := MONColorLinearNormalizer inContext: aGroup withCommand: anObject! !

!MOFilledShape methodsFor: '*mondrian-util' stamp: 'AlexandreBergel 11/8/2011 20:34'!
linearFillColor: anObject within: aGroup highColor: hightColor
	"Set the linear fill color for the nodes. The gradient goes from white to hightColor. anObject could be a symbol, a block or a value. anObject is evaluated against the model of the node to be paint. aGroup is a collection of the model values. This is where the maximum is looked into."

	^ self linearFillColor: anObject within: aGroup highColor: hightColor lowColor: Color white! !

!MOFilledShape methodsFor: '*mondrian-util' stamp: 'AlexandreBergel 11/8/2011 20:34'!
linearFillColor: anObject within: aGroup highColor: hightColor lowColor: lowColor
	"Set the linear fill color for the nodes. The gradient goes from lowColor to hightColor. anObject could be a symbol, a block or a value. anObject is evaluated against the model of the node to be paint. aGroup is a collection of the model values. This is where the maximum is looked into."

	fillColor := MONColorLinearNormalizer 
						inContext: aGroup 
						withCommand: anObject
						lowColor: lowColor
						highColor: hightColor! !

!MOFilledShape methodsFor: '*mondrian-util' stamp: 'AlexandreBergel 4/29/2011 14:50'!
linearGreenFillColor: anObject within: aGroup
	"Set the linear fill color for the nodes. The gradient goes from white to intense green. anObject could be a symbol, a block or a value. anObject is evaluated against the model of the node to be paint. aGroup is a collection of the model values. This is where the maximum is looked into."

	fillColor := MONColorLinearNormalizer 
						inContext: aGroup 
						withCommand: anObject
						lowColor: Color white
						highColor: Color green! !

!MOFilledShape methodsFor: '*mondrian-util' stamp: 'AlexandreBergel 4/29/2011 14:50'!
linearRedFillColor: anObject within: aGroup
	"Set the linear fill color for the nodes. The gradient goes from white to intense red. anObject could be a symbol, a block or a value. anObject is evaluated against the model of the node to be paint. aGroup is a collection of the model values. This is where the maximum is looked into."

	fillColor := MONColorLinearNormalizer 
						inContext: aGroup 
						withCommand: anObject
						lowColor: Color white
						highColor: Color red! !

!MOFilledShape methodsFor: '*mondrian-util' stamp: 'AlexandreBergel 4/29/2011 14:51'!
linearYellowFillColor: anObject within: aGroup
	"Set the linear fill color for the nodes. The gradient goes from white to intense yellow. anObject could be a symbol, a block or a value. anObject is evaluated against the model of the node to be paint. aGroup is a collection of the model values. This is where the maximum is looked into."

	fillColor := MONColorLinearNormalizer 
						inContext: aGroup 
						withCommand: anObject
						lowColor: Color white
						highColor: Color yellow! !

Object subclass: #MOQuadTree
	instanceVariableNames: 'elements quadrants bounds count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Util'!

MOQuadTree class
	instanceVariableNames: 'minExtent maxCount'!

MOQuadTree class
	instanceVariableNames: 'minExtent maxCount'!

!MOQuadTree classSide methodsFor: 'class initialization' stamp: 'simon.denier 6/25/2009 20:26'!
initialize
	super initialize.
	maxCount := 8.
	minExtent := 10 @ 10! !

!MOQuadTree classSide methodsFor: 'accessing' stamp: 'simon.denier 6/25/2009 14:59'!
maxCount

	^ maxCount! !

!MOQuadTree classSide methodsFor: 'accessing' stamp: 'simon.denier 6/25/2009 16:20'!
maxCount: anInteger

	maxCount := anInteger! !

!MOQuadTree classSide methodsFor: 'accessing' stamp: 'simon.denier 6/25/2009 16:38'!
minExtent
	^ minExtent! !

!MOQuadTree classSide methodsFor: 'accessing' stamp: 'simon.denier 6/25/2009 20:26'!
minExtent: aPoint 
	minExtent := aPoint! !

!MOQuadTree classSide methodsFor: 'accessing' stamp: 'simon.denier 6/24/2009 22:56'!
with: aRectangle

	^ self new bounds: aRectangle! !

!MOQuadTree methodsFor: 'public' stamp: 'simon.denier 6/25/2009 16:18'!
addElement: aMOGraphElement 

	self incCount.
	self isComposite ifTrue: [
		(self selectQuadrantsIntersecting: aMOGraphElement bounds) do: [:q | q addElement: aMOGraphElement ]
	] ifFalse: [
		self shouldSplit ifTrue: [
			self splitAdd: aMOGraphElement
		] ifFalse: [
			elements add: aMOGraphElement
		]
	].
	^ aMOGraphElement! !

!MOQuadTree methodsFor: 'basic' stamp: 'AlexandreBergel 10/6/2010 11:04'!
basicAdd: aMOGraphElement

	self incCount.
	elements add: aMOGraphElement! !

!MOQuadTree methodsFor: 'basic' stamp: 'simon.denier 6/25/2009 16:17'!
basicRemove: aMOGraphElement

	self decCount.
	^ elements remove: aMOGraphElement! !

!MOQuadTree methodsFor: 'initialization' stamp: 'simon.denier 6/24/2009 22:55'!
bounds: aRectangle

	bounds := aRectangle  ! !

!MOQuadTree methodsFor: 'geometry' stamp: 'simon.denier 6/24/2009 11:47'!
contains: aPoint

	^ bounds containsPoint: aPoint! !

!MOQuadTree methodsFor: 'basic' stamp: 'simon.denier 6/25/2009 16:16'!
count

	^ count
! !

!MOQuadTree methodsFor: 'basic' stamp: 'simon.denier 6/25/2009 16:17'!
decCount

	count := count - 1! !

!MOQuadTree methodsFor: 'quadrant' stamp: 'simon.denier 6/25/2009 21:23'!
detectQuadrantContaining: aPoint 
	^ quadrants detect: [ :q | q contains: aPoint ]! !

!MOQuadTree methodsFor: 'basic' stamp: 'simon.denier 6/25/2009 15:52'!
elements

	^ elements! !

!MOQuadTree methodsFor: 'public' stamp: 'simon.denier 6/24/2009 13:38'!
findElementsAt: aPoint
	
	^ self isComposite ifTrue: [
		(self detectQuadrantContaining: aPoint) findElementsAt: aPoint
	] ifFalse: [
		elements select: [:e | e bounds containsPoint: aPoint]
	]! !

!MOQuadTree methodsFor: 'public' stamp: 'simon.denier 6/25/2009 15:18'!
findElementsIntersecting: aRectangle

	^ self isComposite ifTrue: [
		(self selectQuadrantsIntersecting: aRectangle) flatCollectAsSet: [:q | q findElementsIntersecting: aRectangle ]
	] ifFalse: [
		elements select: [:e | e bounds intersects: aRectangle ]
	].
! !

!MOQuadTree methodsFor: 'basic' stamp: 'simon.denier 6/25/2009 16:17'!
incCount

	count := count + 1! !

!MOQuadTree methodsFor: 'initialization' stamp: 'simon.denier 6/25/2009 16:11'!
initialize

	elements := OrderedCollection new.
	count := 0.! !

!MOQuadTree methodsFor: 'geometry' stamp: 'simon.denier 6/24/2009 11:34'!
intersects: aRectangle

	^ bounds intersects: aRectangle ! !

!MOQuadTree methodsFor: 'basic' stamp: 'simon.denier 6/24/2009 23:28'!
isComposite

	^ quadrants notNil! !

!MOQuadTree methodsFor: 'quadrant' stamp: 'simon.denier 6/25/2009 15:56'!
mergeQuadrants

	elements := quadrants flatCollectAsSet: [:q | q elements	].
	quadrants := nil.! !

!MOQuadTree methodsFor: 'public' stamp: 'simon.denier 6/25/2009 16:17'!
removeElement: aMOGraphElement
	"remove elements from quadrants, merge them if necessary"
	
	self decCount.
	self isComposite ifTrue: [
		(self selectQuadrantsIntersecting: aMOGraphElement bounds) do:
			[:q | q removeElement: aMOGraphElement ].
		self shouldMerge ifTrue: [
			self mergeQuadrants
		]
	] ifFalse: [
		elements remove: aMOGraphElement 
	].
	^ aMOGraphElement ! !

!MOQuadTree methodsFor: 'quadrant' stamp: 'simon.denier 6/24/2009 13:27'!
selectQuadrantsIntersecting: aRectangle 
	^ quadrants select: [ :q | q intersects: aRectangle ]! !

!MOQuadTree methodsFor: 'quadrant' stamp: 'simon.denier 6/25/2009 15:09'!
shouldMerge

	^ self count <= self class maxCount! !

!MOQuadTree methodsFor: 'quadrant' stamp: 'simon.denier 6/25/2009 20:25'!
shouldSplit
	"Split a leaf Quadtree only if the quadtree has reached its maximum capacity
	and it is big enough to be split"
	^ self count > self class maxCount and: [ bounds extent > self class minExtent ]! !

!MOQuadTree methodsFor: 'quadrant' stamp: 'Alexandre.Bergel 8/30/2009 15:59'!
splitAdd: aMOGraphElement

	| topleft topright bottomright bottomleft |
	"create the four quadrants"
	topleft := self class with: (bounds origin corner: bounds center).
	topright := self class with: (bounds topCenter corner: bounds rightCenter).
	bottomright := self class with: (bounds center corner: bounds corner).
	bottomleft := self class with: (bounds leftCenter corner: bounds bottomCenter).
	quadrants := {topleft. topright. bottomright. bottomleft}.
	
	"dispatch all elements in the four quadrants"
	elements do: [:e |
		"since each quadrant is fresh, we can safely add each element without testing for capacity"
		(self selectQuadrantsIntersecting: e bounds) do: [:q | q basicAdd: e]
	].
	elements := elements copyEmpty. "remove all elements"
	
	"we have now created a composite Quadtree, we can add the new element, 	eventually splitting quadrants if necessary."
	(self selectQuadrantsIntersecting: aMOGraphElement bounds) do: [:q | q addElement: aMOGraphElement ]! !

TestCase subclass: #XKCDColorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Util-Tests'!

!XKCDColorTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/8/2011 00:03'!
testXKCDColor
	"A bit weird"
	self assert: (XKCDColor new) = Color black.
	
	self assert: (XKCDColor named: 'black') = Color black.
	
	XKCDColor initColormap1! !

Color subclass: #XKCDColor
	instanceVariableNames: 'name'
	classVariableNames: 'Colormap'
	poolDictionaries: ''
	category: 'Mondrian-Util'!

!XKCDColor commentStamp: '<historical>' prior: 0!
A color named according to the XKCD color survey, as published in http://blog.xkcd.com/2010/05/03/color-survey-results/ ("Over five million colors were named across 222,500 user sessions.")

Of the full table of 954 colors that is published only those were selected that did not have a space in their name, ignoring e.g. electric lime, nasty green, macaroni and cheese, pinkish tan, but also light light blue, strong blue. This results in a table of 261 named colors, but with duplicates such as ochre and ocre. These were left in since as they are common misspellings it is more convenient for the user.

To instantiate: XCDColor named: aString where aString is one of the 261 named colors. If the name is not known, the color red is instantiated. Instances of XKCDColor know their XKCD color name, returned by the name accessor.

Thanks to Randall Monroe of http://xkcd.com for providing the data.!

!XKCDColor classSide methodsFor: 'accessing' stamp: 'AlexandreBergel 5/18/2011 15:59'!
colormap
	Colormap ifNil: [self initColormap1].
	^ Colormap! !

!XKCDColor classSide methodsFor: 'initialize-release' stamp: 'AlexandreBergel 5/18/2011 16:00'!
initColormap1.
	Colormap := Dictionary new.
	"truncated due to method literal limit"
Colormap add: 'adobe' -> '#bd6c48' .
Colormap add: 'algae' -> '#54ac68' .
Colormap add: 'amber' -> '#feb308' .
Colormap add: 'amethyst' -> '#9b5fc0' .
Colormap add: 'apple' -> '#6ecb3c' .
Colormap add: 'apricot' -> '#ffb16d' .
Colormap add: 'aqua' -> '#13eac9' .
Colormap add: 'aquamarine' -> '#04d8b2' .
Colormap add: 'asparagus' -> '#77ab56' .
Colormap add: 'aubergine' -> '#3d0734' .
Colormap add: 'auburn' -> '#9a3001' .
Colormap add: 'avocado' -> '#90b134' .
Colormap add: 'azul' -> '#1d5dec' .
Colormap add: 'azure' -> '#069af3' .
Colormap add: 'banana' -> '#ffff7e' .
Colormap add: 'barney' -> '#ac1db8' .
Colormap add: 'beige' -> '#e6daa6' .
Colormap add: 'berry' -> '#990f4b' .
Colormap add: 'bile' -> '#b5c306' .
Colormap add: 'black' -> '#000000' .
Colormap add: 'bland' -> '#afa88b' .
Colormap add: 'blood' -> '#770001' .
Colormap add: 'blue' -> '#0343df' .
Colormap add: 'blue/green' -> '#0f9b8e' .
Colormap add: 'blue/grey' -> '#758da3' .
Colormap add: 'blue/purple' -> '#5a06ef' .
Colormap add: 'blueberry' -> '#464196' .
Colormap add: 'bluegreen' -> '#017a79' .
Colormap add: 'bluegrey' -> '#85a3b2' .
Colormap add: 'bluish' -> '#2976bb' .
Colormap add: 'blurple' -> '#5539cc' .
Colormap add: 'blush' -> '#f29e8e' .
Colormap add: 'booger' -> '#9bb53c' .
Colormap add: 'bordeaux' -> '#7b002c' .
Colormap add: 'brick' -> '#a03623' .
Colormap add: 'bronze' -> '#a87900' .
Colormap add: 'brown' -> '#653700' .
Colormap add: 'brownish' -> '#9c6d57' .
Colormap add: 'bruise' -> '#7e4071' .
Colormap add: 'bubblegum' -> '#ff6cb5' .
Colormap add: 'buff' -> '#fef69e' .
Colormap add: 'burgundy' -> '#610023' .
Colormap add: 'burple' -> '#6832e3' .
Colormap add: 'butter' -> '#ffff81' .
Colormap add: 'butterscotch' -> '#fdb147' .
Colormap add: 'camel' -> '#c69f59' .
Colormap add: 'camo' -> '#7f8f4e' .
Colormap add: 'canary' -> '#fdff63' .
Colormap add: 'caramel' -> '#af6f09' .
Colormap add: 'carmine' -> '#9d0216' .
Colormap add: 'carnation' -> '#fd798f' .
Colormap add: 'celadon' -> '#befdb7' .
Colormap add: 'celery' -> '#c1fd95' .
Colormap add: 'cement' -> '#a5a391' .
Colormap add: 'cerise' -> '#de0c62' .
Colormap add: 'cerulean' -> '#0485d1' .
Colormap add: 'charcoal' -> '#343837' .
Colormap add: 'chartreuse' -> '#c1f80a' .
Colormap add: 'cherry' -> '#cf0234' .
Colormap add: 'chestnut' -> '#742802' .
Colormap add: 'chocolate' -> '#3d1c02' .
Colormap add: 'cinnamon' -> '#ac4f06' .
Colormap add: 'claret' -> '#680018' .
Colormap add: 'clay' -> '#b66a50' .
Colormap add: 'cobalt' -> '#1e488f' .
Colormap add: 'cocoa' -> '#875f42' .
Colormap add: 'coffee' -> '#a6814c' .
Colormap add: 'copper' -> '#b66325' .
Colormap add: 'coral' -> '#fc5a50' .
Colormap add: 'cornflower' -> '#6a79f7' .
Colormap add: 'cranberry' -> '#9e003a' .
Colormap add: 'cream' -> '#ffffc2' .
Colormap add: 'creme' -> '#ffffb6' .
Colormap add: 'crimson' -> '#8c000f' .
self initColormap2.! !

!XKCDColor classSide methodsFor: 'initialize-release' stamp: 'AlexandreBergel 5/18/2011 16:00'!
initColormap2 
	"followed from 1"
Colormap add: 'custard' -> '#fffd78' .
Colormap add: 'cyan' -> '#00ffff' .
Colormap add: 'dandelion' -> '#fedf08' .
Colormap add: 'dark' -> '#1b2431' .
Colormap add: 'darkblue' -> '#030764' .
Colormap add: 'darkgreen' -> '#054907' .
Colormap add: 'denim' -> '#3b638c' .
Colormap add: 'desert' -> '#ccad60' .
Colormap add: 'diarrhea' -> '#9f8303' .
Colormap add: 'dirt' -> '#8a6e45' .
Colormap add: 'drab' -> '#828344' .
Colormap add: 'dusk' -> '#4e5481' .
Colormap add: 'dust' -> '#b2996e' .
Colormap add: 'earth' -> '#a2653e' .
Colormap add: 'ecru' -> '#feffca' .
Colormap add: 'eggplant' -> '#380835' .
Colormap add: 'eggshell' -> '#ffffd4' .
Colormap add: 'emerald' -> '#01a049' .
Colormap add: 'evergreen' -> '#05472a' .
Colormap add: 'fawn' -> '#cfaf7b' .
Colormap add: 'fern' -> '#63a950' .
Colormap add: 'forest' -> '#0b5509' .
Colormap add: 'fuchsia' -> '#ed0dd9' .
Colormap add: 'gold' -> '#dbb40c' .
Colormap add: 'golden' -> '#f5bf03' .
Colormap add: 'goldenrod' -> '#fac205' .
Colormap add: 'grape' -> '#6c3461' .
Colormap add: 'grapefruit' -> '#fd5956' .
Colormap add: 'grass' -> '#5cac2d' .
Colormap add: 'green' -> '#15b01a' .
Colormap add: 'green/blue' -> '#01c08d' .
Colormap add: 'green/yellow' -> '#b5ce08' .
Colormap add: 'greenblue' -> '#23c48b' .
Colormap add: 'greenish' -> '#40a368' .
Colormap add: 'grey' -> '#929591' .
Colormap add: 'grey/blue' -> '#647d8e' .
Colormap add: 'grey/green' -> '#86a17d' .
Colormap add: 'greyblue' -> '#77a1b5' .
Colormap add: 'greyish' -> '#a8a495' .
Colormap add: 'gunmetal' -> '#536267' .
Colormap add: 'hazel' -> '#8e7618' .
Colormap add: 'heather' -> '#a484ac' .
Colormap add: 'heliotrope' -> '#d94ff5' .
Colormap add: 'ice' -> '#d6fffa' .
Colormap add: 'indigo' -> '#380282' .
Colormap add: 'iris' -> '#6258c4' .
Colormap add: 'ivory' -> '#ffffcb' .
Colormap add: 'jade' -> '#1fa774' .
Colormap add: 'khaki' -> '#aaa662' .
Colormap add: 'kiwi' -> '#9cef43' .
Colormap add: 'lavender' -> '#c79fef' .
Colormap add: 'leaf' -> '#71aa34' .
Colormap add: 'leather' -> '#ac7434' .
Colormap add: 'lemon' -> '#fdff52' .
Colormap add: 'lichen' -> '#8fb67b' .
Colormap add: 'lightblue' -> '#7bc8f6' .
Colormap add: 'lightgreen' -> '#76ff7b' .
Colormap add: 'lilac' -> '#cea2fd' .
Colormap add: 'liliac' -> '#c48efd' .
Colormap add: 'lime' -> '#aaff32' .
Colormap add: 'lipstick' -> '#d5174e' .
Colormap add: 'magenta' -> '#c20078' .
Colormap add: 'mahogany' -> '#4a0100' .
Colormap add: 'maize' -> '#f4d054' .
Colormap add: 'mango' -> '#ffa62b' .
Colormap add: 'manilla' -> '#fffa86' .
Colormap add: 'marigold' -> '#fcc006' .
Colormap add: 'marine' -> '#042e60' .
Colormap add: 'maroon' -> '#650021' .
Colormap add: 'mauve' -> '#ae7181' .
Colormap add: 'melon' -> '#ff7855' .
Colormap add: 'merlot' -> '#730039' .
Colormap add: 'midnight' -> '#03012d' .
Colormap add: 'mint' -> '#9ffeb0' .

self initColormap3! !

!XKCDColor classSide methodsFor: 'initialize-release' stamp: 'AlexandreBergel 5/18/2011 16:00'!
initColormap3
	"followed from 2"
Colormap add: 'mocha' -> '#9d7651' .
Colormap add: 'moss' -> '#769958' .
Colormap add: 'mud' -> '#735c12' .
Colormap add: 'mulberry' -> '#920a4e' .
Colormap add: 'mushroom' -> '#ba9e88' .
Colormap add: 'mustard' -> '#ceb301' .
Colormap add: 'navy' -> '#01153e' .
Colormap add: 'ocean' -> '#017b92' .
Colormap add: 'ocher' -> '#bf9b0c' .
Colormap add: 'ochre' -> '#bf9005' .
Colormap add: 'ocre' -> '#c69c04' .
Colormap add: 'olive' -> '#6e750e' .
Colormap add: 'orange' -> '#f97306' .
Colormap add: 'orangeish' -> '#fd8d49' .
Colormap add: 'orangered' -> '#fe420f' .
Colormap add: 'orangish' -> '#fc824a' .
Colormap add: 'orchid' -> '#c875c4' .
Colormap add: 'pale' -> '#fff9d0' .
Colormap add: 'parchment' -> '#fefcaf' .
Colormap add: 'pea' -> '#a4bf20' .
Colormap add: 'peach' -> '#ffb07c' .
Colormap add: 'pear' -> '#cbf85f' .
Colormap add: 'periwinkle' -> '#8e82fe' .
Colormap add: 'perrywinkle' -> '#8f8ce7' .
Colormap add: 'petrol' -> '#005f6a' .
Colormap add: 'pine' -> '#2b5d34' .
Colormap add: 'pink' -> '#ff81c0' .
Colormap add: 'pink/purple' -> '#ef1de7' .
Colormap add: 'pinkish' -> '#d46a7e' .
Colormap add: 'pinky' -> '#fc86aa' .
Colormap add: 'pistachio' -> '#c0fa8b' .
Colormap add: 'plum' -> '#580f41' .
Colormap add: 'poo' -> '#8f7303' .
Colormap add: 'poop' -> '#7f5e00' .
Colormap add: 'puce' -> '#a57e52' .
Colormap add: 'puke' -> '#a5a502' .
Colormap add: 'pumpkin' -> '#e17701' .
Colormap add: 'purple' -> '#7e1e9c' .
Colormap add: 'purple/blue' -> '#5d21d0' .
Colormap add: 'purple/pink' -> '#d725de' .
Colormap add: 'purpleish' -> '#98568d' .
Colormap add: 'purpley' -> '#8756e4' .
Colormap add: 'purplish' -> '#94568c' .
Colormap add: 'purply' -> '#983fb2' .
Colormap add: 'putty' -> '#beae8a' .
Colormap add: 'raspberry' -> '#b00149' .
Colormap add: 'red' -> '#e50000' .
Colormap add: 'reddish' -> '#c44240' .
Colormap add: 'rosa' -> '#fe86a4' .
Colormap add: 'rose' -> '#cf6275' .
Colormap add: 'rouge' -> '#ab1239' .
Colormap add: 'royal' -> '#0c1793' .
Colormap add: 'ruby' -> '#ca0147' .
Colormap add: 'russet' -> '#a13905' .
Colormap add: 'rust' -> '#a83c09' .
Colormap add: 'saffron' -> '#feb209' .
Colormap add: 'sage' -> '#87ae73' .
Colormap add: 'salmon' -> '#ff796c' .
Colormap add: 'sand' -> '#e2ca76' .
Colormap add: 'sandstone' -> '#c9ae74' .
Colormap add: 'sandy' -> '#f1da7a' .
Colormap add: 'sapphire' -> '#2138ab' .
Colormap add: 'scarlet' -> '#be0119' .
Colormap add: 'sea' -> '#3c9992' .
Colormap add: 'seafoam' -> '#80f9ad' .
Colormap add: 'seaweed' -> '#18d17b' .
Colormap add: 'sepia' -> '#985e2b' .
Colormap add: 'shamrock' -> '#01b44c' .
Colormap add: 'shit' -> '#7f5f00' .
Colormap add: 'sienna' -> '#a9561e' .
Colormap add: 'silver' -> '#c5c9c7' .
Colormap add: 'sky' -> '#82cafc' .
Colormap add: 'slate' -> '#516572' .
Colormap add: 'snot' -> '#acbb0d' .
Colormap add: 'spearmint' -> '#1ef876' .
Colormap add: 'spruce' -> '#0a5f38' .
Colormap add: 'squash' -> '#f2ab15' .
Colormap add: 'steel' -> '#738595' .
Colormap add: 'stone' -> '#ada587' .
Colormap add: 'straw' -> '#fcf679' .
Colormap add: 'strawberry' -> '#fb2943' .
Colormap add: 'sunflower' -> '#ffc512' .
Colormap add: 'swamp' -> '#698339' .
Colormap add: 'tan' -> '#d1b26f' .
Colormap add: 'tangerine' -> '#ff9408' .
Colormap add: 'taupe' -> '#b9a281' .
Colormap add: 'tea' -> '#65ab7c' .
Colormap add: 'teal' -> '#029386' .
Colormap add: 'tealish' -> '#24bca8' .
Colormap add: 'terracota' -> '#cb6843' .
Colormap add: 'terracotta' -> '#ca6641' .
Colormap add: 'tomato' -> '#ef4026' .
Colormap add: 'topaz' -> '#13bbaf' .
Colormap add: 'toupe' -> '#c7ac7d' .
Colormap add: 'turquoise' -> '#06c2ac' .
Colormap add: 'twilight' -> '#4e518b' .
Colormap add: 'ultramarine' -> '#2000b1' .
Colormap add: 'umber' -> '#b26400' .
Colormap add: 'velvet' -> '#750851' .
Colormap add: 'vermillion' -> '#f4320c' .
Colormap add: 'violet' -> '#9a0eea' .
Colormap add: 'viridian' -> '#1e9167' .
Colormap add: 'vomit' -> '#a2a415' .
Colormap add: 'watermelon' -> '#fd4659' .
Colormap add: 'wheat' -> '#fbdd7e' .
Colormap add: 'white' -> '#ffffff' .
Colormap add: 'wine' -> '#80013f' .
Colormap add: 'wintergreen' -> '#20f986' .
Colormap add: 'wisteria' -> '#a87dc2' .
Colormap add: 'yellow' -> '#ffff14' .
Colormap add: 'yellow/green' -> '#c8fd3d' .
Colormap add: 'yellowgreen' -> '#bbf90f' .
Colormap add: 'yellowish' -> '#faee66' .
! !

!XKCDColor classSide methodsFor: 'public' stamp: 'AlexandreBergel 1/8/2011 00:00'!
named: aString
	"Return an instance of myself that correspond to the name aString. 
	If no color does exist, then red is returned"
	
	| inst |
	inst := self fromString: (self colormap at: aString ifAbsent: [self colormap at: 'red']).
	inst name: aString.
	^inst
	! !

!XKCDColor methodsFor: 'accessing' stamp: 'JF 10/23/2010 14:54'!
name
	^ name
! !

!XKCDColor methodsFor: 'accessing' stamp: 'JF 10/23/2010 14:54'!
name: anObject
	name := anObject! !
MOQuadTree initialize!
